//Downloaded from
//Visual C# Kicks - http://vckicks.110mb.com/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ScreenLock
{
    public partial class SimpleLock : Form
    {
        //This example will create a form that will block the entire screen
        //until the user enters the correct password on a textbox and hits Enter.
        //After 3 tries the program will lock until a key is pressed (F7 is default)
        //If the program is closed improperly it will run another instance of itself

        public SimpleLock()
        {
            InitializeComponent();

            //Get a bare, black form to cover the entire screen
            this.BackColor = Color.Black;
            this.CausesValidation = false;
            this.StartPosition = FormStartPosition.Manual;
            this.WindowState = FormWindowState.Maximized;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.ShowInTaskbar = false;
            this.TopMost = true;

            //Set the password textbox
            txtPassword.PasswordChar = '*';
            txtPassword.TextAlign = HorizontalAlignment.Center;
            txtPassword.BackColor = Color.DarkGray;
            txtPassword.ForeColor = Color.Yellow;
            txtPassword.BorderStyle = BorderStyle.None;

            //Timer
            layerTimer.Interval = 1;
            layerTimer.Enabled = true;
        }

        int tries;
        bool approveClose;

        private void Form1_Load(object sender, EventArgs e)
        {
            //Place the password textbox in the middle
            txtPassword.Left = (this.Width / 2) - (txtPassword.Width / 2);
            txtPassword.Top = (this.Height / 2) - (txtPassword.Height / 2);
        }

        private void txtPassword_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Enter))
            {
                //Check the password
                //Can use fancy algorithm or simple check
                //depends on the purpose, for here we'll just check
                //that the string matches the password
                if (txtPassword.Text == "password")
                {
                    approveClose = true;
                    this.Close();
                }
                else
                {
                    tries++;
                    txtPassword.Text = string.Empty;

                    if (tries >= 3) //too many tries, disable
                    {
                        txtPassword.Enabled = false;
                        txtPassword.Visible = false;
                    }
                }
            }
        }

        private void SimpleLock_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.F7 && tries >= 3)
            {
                //Reset the try countersec
                tries = 0;
                txtPassword.Enabled = true;
                txtPassword.Visible = true;
                txtPassword.Focus();
            }
        }

        private void layerTimer_Tick(object sender, EventArgs e)
        {
            //this is a brute force way of doing things, but by constantly
            //bringing our top-most form to the front, we can prevent
            //anything else from showing up on top (like TaskManager for example)
            this.BringToFront();
            if (!txtPassword.Focused) txtPassword.Focus();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            //If the form wasn't closed by entering the proper password (like Alt F40
            //run the program again
            //if (!approveClose)
            //    System.Diagnostics.Process.Start(Application.ExecutablePath);
        }       
    }
}